<template>
  <section id="note-item">
    <div class="container">
      <div class="row">
        <div class="col-12 col-sm-6 ">
          <form
            v-if="note"
            ref="form"
            class="text-left"
          >
            <div class="form-group">
              <label for="titleField">название :</label>
              <input
                id="titleField"
                class="form-control"
                type="text"
                v-model="note.title"
                placeholder="введите название "
                required
              />
            </div>

            <div class="note-todos__list">
              <button
                type="button"
                class="btn btn-primary my-4"
                @click="addEmptyTodo"
              >Добавить задачу</button>

              <!-- Задачи -->
              <note-todo-item
                ref="todoItem"
                v-for="(todo, index) in note.todos"
                :todo="todo"
                :key="index"
                :index="index"
                @add-item="addEmptyLineAfterThis"
                @remove="removeTodo"
              />
              <div><small>(!) Вы можете нажать ctrl+Enter чтобы создать следующую задачу</small></div>
            </div>
            <!-- Действия наад Заметкой -->
            <button
              type="button"
              class="btn btn-primary mb-2 mt-4 mr-2"
              @click="save"
            >Сохранить изменения</button>

            <button
              type="button"
              class="btn btn-warning mb-2 mt-4 mr-2"
              @click="cancelChangesConfirm"
            >Отменить изменения <small>(После последнего сохранения)</small></button>
            <button
              v-if="id !== 'new'"
              type="button"
              class="btn btn-danger mb-2 mt-4"
              @click="deleteNoteConfirm"
            >Удалить заметку</button>

            <!-- Redo/Undo -->
            <div
              v-if="canRedo || canUndo"
              class="btn-group"
              role="group"
              aria-label="Basic example"
            >
              <button
                :disabled="!canUndo"
                type="button"
                class="btn btn-secondary"
                @click="undoAndSync"
              >отменить внесенное изменение</button>
              <button
                :disabled="!canRedo"
                type="button"
                class="btn btn-secondary"
                @click="redoAndSync"
              >повторить отмененное изменение</button>
            </div>
          </form>
        </div>
      </div>
    </div>
    <confirm-modal ref="confirm" />
  </section>
</template>

<script>
import { mapGetters } from "vuex";
import ConfirmModal from "../components/ConfirmModal";
import { cloneDeep } from "lodash";
import NoteTodoItem from "../components/Form/NoteTodoItem";

let ID = function() {
  // Math.random should be unique because of its seeding algorithm.
  // Convert it to base 36 (numbers + letters), and grab the first 9 characters
  // after the decimal.
  return (
    "_" +
    Math.random()
      .toString(36)
      .substr(2, 9)
  );
};
let defaultNote = function() {
  return {
    id: ID(),
    title: "",
    todos: []
  };
};

export default {
  components: { NoteTodoItem, ConfirmModal },
  props: {
    id: {
      required: true
    }
  },
  data() {
    return {
      note: null,
      initalState: null
    };
  },
  computed: {
    ...mapGetters(["getNoteById", "getNoteTodos"])
  },
  mounted() {
    this.initData();
    this.initialState = cloneDeep(this.note);
  },
  beforeRouteUpdate() {
    this.initData();
  },
  beforeRouteChange(from, to, next) {
    next(vm => {
      vm.id = to.params.id;
    });
  },
  methods: {
    /**
     * Переопределить note значения из хранилища
     */
    initData() {
      if (this.id === "new") {
        this.note = defaultNote();
      } else {
        this.note = cloneDeep(this.getNoteById(this.id)) || null;
        console.log(this.note);
        if (this.note == null) {
          this.$router.push("/404");
        }

        let todos = cloneDeep(this.getNoteTodos(this.id));

        this.note.todos = todos;
      }
    },
    /**
     * Сохранение изменении в Store-е
     */
    save() {
      if (!this.$refs.form.checkValidity()) {
        this.$refs.form.submit();
        return;
      }
      this.$store.commit("SYNC_NOTE", {
        ...this.note,
        todos: this.note.todos.filter(todo => todo.text !== "")
      });
      alert("Сохранено");

      if (this.id === "new") {
        let path = `/note/${this.note.id}`;
        this.$router.push({ path: "/" }).then(() => {
          this.$router.push({ path });
        });
      }

      // this.initData();
    },
    /** Добавляет пустой todo item после текущего при нажатии на ctrl+e на Text Input-е */
    addEmptyLineAfterThis(e, index) {
      if (!e.ctrlKey) {
        return;
      }
      let key = index + 1;
      this.note.todos.splice(key, 0, {
        id: ID(),
        completed: false,
        text: ""
      });
      this.focusInput(key);
    },
    /**
     * Добавляет пустой todo item в конце
     */
    addEmptyTodo() {
      this.note.todos.push({
        id: ID(),
        completed: false,
        text: ""
      });
      this.focusInput();
    },
    focusInput(index = null) {
      this.$nextTick(() => {
        let key = index || this.$refs.todoItem.length - 1;
        this.$refs.todoItem[key].setFocusToInput();
      });
    },
    removeTodo(index) {
      this.note.todos.splice(index, 1);
    },
    /**
     * Откат последнего изменения
     */
    undoAndSync() {
      this.undo();
      this.initData();
    },
    /**
     * Повторить последний откат
     */
    redoAndSync() {
      this.redo();
      this.initData();
    },
    /**
     * Отмеа изменении сделанных после сохранения
     */
    cancelChangesConfirm() {
      this.$refs.confirm
        .open("Хотите отменить? Действие необратимо! ")
        .done(() => {
          this.initData();
        });
    },
    /**
     * Удаление заметки самой заметки и переход на главную
     */
    deleteNoteConfirm() {
      this.$refs.confirm
        .open("Хотите удалить заметку? Действие необратимо! ")
        .done(() => {
          this.$store.commit("DELETE_NOTE", this.note.id);
          this.$router.push("/");
        });
    }
  }
};
</script>

<style lang="scss">
.todo__completed-mark {
  width: 32px;
  height: 32px;
  margin: 0;
}

.note-todos__mark-wrp {
  display: flex;
  align-items: center;
  justify-content: center;
}
</style>
